'use strict';Object.defineProperty(exports,"__esModule",{value:!0});var graphqlExtensions=require("graphql-extensions");const isFunction=e=>e&&"[object Function]"==={}.toString.call(e);class FormatErrorWithContextExtension extends graphqlExtensions.GraphQLExtension{constructor(e){super(),this.formatError=e}willSendResponse(e){const{context:n,graphqlResponse:o}=e;return o.errors&&isFunction(this.formatError)&&(o.errors=o.errors.map(e=>this.formatError(e,n))),e}}/* -*- Mode: js; js-indent-level: 2; -*- */ /*
 * Copyright 2011 Mozilla Foundation and contributors
 * Licensed under the New BSD license. See LICENSE or:
 * http://opensource.org/licenses/BSD-3-Clause
 */var intToCharMap=["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","0","1","2","3","4","5","6","7","8","9","+","/"],encode=function(e){if(0<=e&&e<intToCharMap.length)return intToCharMap[e];throw new TypeError("Must be between 0 and 63: "+e)},decode=function(e){var n=97,o=48;// 'A'
// 0 - 25: ABCDEFGHIJKLMNOPQRSTUVWXYZ
return 65<=e&&e<=90?e-65:n<=e&&e<=122?e-n+26:o<=e&&e<=57?e-o+52:e==43?62:e==47?63:-1;// 26 - 51: abcdefghijklmnopqrstuvwxyz
// 52 - 61: 0123456789
// 62: +
// 63: /
// Invalid base64 digit.
},base64={encode:encode,decode:decode},VLQ_BASE_SHIFT=5,VLQ_BASE=1<<VLQ_BASE_SHIFT,VLQ_BASE_MASK=VLQ_BASE-1,VLQ_CONTINUATION_BIT=VLQ_BASE;/**
 * Encode an integer in the range of 0 to 63 to a single base 64 digit.
 */ /**
 * Converts from a two-complement value to a value where the sign bit is
 * placed in the least significant bit.  For example, as decimals:
 *   1 becomes 2 (10 binary), -1 becomes 3 (11 binary)
 *   2 becomes 4 (100 binary), -2 becomes 5 (101 binary)
 */function toVLQSigned(e){return 0>e?(-e<<1)+1:(e<<1)+0}/**
 * Converts to a two-complement value from a value where the sign bit is
 * placed in the least significant bit.  For example, as decimals:
 *   2 (10 binary) becomes 1, 3 (11 binary) becomes -1
 *   4 (100 binary) becomes 2, 5 (101 binary) becomes -2
 */function fromVLQSigned(e){var n=e>>1;return 1==(1&e)?-n:n}/**
 * Returns the base 64 VLQ encoded value.
 */var encode$1=function(e){var n,o="",r=toVLQSigned(e);do n=r&VLQ_BASE_MASK,r>>>=VLQ_BASE_SHIFT,0<r&&(n|=VLQ_CONTINUATION_BIT),o+=base64.encode(n);while(0<r);return o},decode$1=function(e,n,o){var r,t,i=e.length,a=0,s=0;do{if(n>=i)throw new Error("Expected more digits in base 64 VLQ value.");if(t=base64.decode(e.charCodeAt(n++)),-1===t)throw new Error("Invalid base64 digit: "+e.charAt(n-1));r=!!(t&VLQ_CONTINUATION_BIT),t&=VLQ_BASE_MASK,a+=t<<s,s+=VLQ_BASE_SHIFT}while(r);o.value=fromVLQSigned(a),o.rest=n},base64Vlq={encode:encode$1,decode:decode$1};/**
 * Decodes the next base 64 VLQ value from the given string and returns the
 * value and the rest of the string via the out parameter.
 */function createCommonjsModule(e,n){return n={exports:{}},e(n,n.exports),n.exports}var util=createCommonjsModule(function(e,n){/* -*- Mode: js; js-indent-level: 2; -*- */ /*
 * Copyright 2011 Mozilla Foundation and contributors
 * Licensed under the New BSD license. See LICENSE or:
 * http://opensource.org/licenses/BSD-3-Clause
 */ /**
 * This is a helper function for getting values from parameter/options
 * objects.
 *
 * @param args The object we are extracting values from
 * @param name The name of the property we are getting.
 * @param defaultValue An optional value to return if the property is missing
 * from the object. If this is not specified and the property is missing, an
 * error will be thrown.
 */function o(e,n,o){if(n in e)return e[n];if(3===arguments.length)return o;throw new Error("\""+n+"\" is a required argument.")}function r(e){var n=e.match(l);return n?{scheme:n[1],auth:n[2],host:n[3],port:n[4],path:n[5]}:null}function t(e){var n="";return e.scheme&&(n+=e.scheme+":"),n+="//",e.auth&&(n+=e.auth+"@"),e.host&&(n+=e.host),e.port&&(n+=":"+e.port),e.path&&(n+=e.path),n}/**
 * Normalizes a path, or the path portion of a URL:
 *
 * - Replaces consecutive slashes with one slash.
 * - Removes unnecessary '.' parts.
 * - Removes unnecessary '<dir>/..' parts.
 *
 * Based on code in the Node.js 'path' core module.
 *
 * @param aPath The path or url to normalize.
 */function i(e){var o=e,a=r(e);if(a){if(!a.path)return e;o=a.path}for(var s,u=n.isAbsolute(o),d=o.split(/\/+/),l=0,c=d.length-1;0<=c;c--)s=d[c],"."===s?d.splice(c,1):".."===s?l++:0<l&&(""===s?(d.splice(c+1,l),l=0):(d.splice(c,2),l--));return o=d.join("/"),""===o&&(o=u?"/":"."),a?(a.path=o,t(a)):o}/**
 * Joins two paths/URLs.
 *
 * @param aRoot The root path or URL.
 * @param aPath The path or URL to be joined with the root.
 *
 * - If aPath is a URL or a data URI, aPath is returned, unless aPath is a
 *   scheme-relative URL: Then the scheme of aRoot, if any, is prepended
 *   first.
 * - Otherwise aPath is a path. If aRoot is a URL, then its path portion
 *   is updated with the result and aRoot is returned. Otherwise the result
 *   is returned.
 *   - If aPath is absolute, the result is aPath.
 *   - Otherwise the two paths are joined with a slash.
 * - Joining for example 'http://' and 'www.example.com' is also supported.
 */function a(e,n){""===e&&(e="."),""===n&&(n=".");var o=r(n),a=r(e);// `join(foo, '//www.example.org')`
if(a&&(e=a.path||"/"),o&&!o.scheme)return a&&(o.scheme=a.scheme),t(o);if(o||n.match(c))return n;// `join('http://', 'www.example.com')`
if(a&&!a.host&&!a.path)return a.host=n,t(a);var s="/"===n.charAt(0)?n:i(e.replace(/\/+$/,"")+"/"+n);return a?(a.path=s,t(a)):s}function s(e){return e}/**
 * Because behavior goes wacky when you set `__proto__` on objects, we
 * have to prefix all the strings in our set with an arbitrary character.
 *
 * See https://github.com/mozilla/source-map/pull/31 and
 * https://github.com/mozilla/source-map/issues/30
 *
 * @param String aStr
 */function u(e){if(!e)return(/** async */!1);var n=e.length;if(9>n/* "__proto__".length */)return!1;if(95!==e.charCodeAt(n-1)/* '_' */||95!==e.charCodeAt(n-2)/* '_' */||111!==e.charCodeAt(n-3)/* 'o' */||116!==e.charCodeAt(n-4)/* 't' */||111!==e.charCodeAt(n-5)/* 'o' */||114!==e.charCodeAt(n-6)/* 'r' */||112!==e.charCodeAt(n-7)/* 'p' */||95!==e.charCodeAt(n-8)/* '_' */||95!==e.charCodeAt(n-9)/* '_' */)return!1;for(var o=n-10;0<=o;o--)if(36!==e.charCodeAt(o)/* '$' */)return!1;return!0}/**
 * Comparator between two mappings where the original positions are compared.
 *
 * Optionally pass in `true` as `onlyCompareGenerated` to consider two
 * mappings with the same original source/line/column, but different generated
 * line and column the same. Useful when searching for a mapping with a
 * stubbed out mapping.
 */function d(e,n){return e===n?0:null===e?1:null===n?-1:e>n?1:-1}/**
 * Comparator between two mappings with inflated source and name strings where
 * the generated positions are compared.
 */n.getArg=o;var l=/^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.-]*)(?::(\d+))?(.*)$/,c=/^data:.+\,.+$/;n.urlParse=r,n.urlGenerate=t,n.normalize=i,n.join=a,n.isAbsolute=function(e){return"/"===e.charAt(0)||l.test(e)},n.relative=/**
 * Make a path relative to a URL or another path.
 *
 * @param aRoot The root path or URL.
 * @param aPath The path or URL to be made relative to aRoot.
 */function(e,n){""===e&&(e="."),e=e.replace(/\/$/,"");for(// It is possible for the path to be above the root. In this case, simply
// checking whether the root is a prefix of the path won't work. Instead, we
// need to remove components from the root one by one, until either we find
// a prefix that fits, or we run out of components to remove.
var o,r=0;0!==n.indexOf(e+"/");){if(o=e.lastIndexOf("/"),0>o)return n;// If the only part of the root that is left is the scheme (i.e. http://,
// file:///, etc.), one or more slashes (/), or simply nothing at all, we
// have exhausted all components, so the path is not relative to the root.
if(e=e.slice(0,o),e.match(/^([^\/]+:\/)?\/*$/))return n;++r}// Make sure we add a "../" for each component we removed from the root.
return Array(r+1).join("../")+n.substr(e.length+1)};var g=function(){var e=Object.create(null);return!("__proto__"in e)}();n.toSetString=g?s:function(e){return u(e)?"$"+e:e},n.fromSetString=g?s:function(e){return u(e)?e.slice(1):e},n.compareByOriginalPositions=function(e,n,o){var r=d(e.source,n.source);return 0===r?(r=e.originalLine-n.originalLine,0!==r)?r:(r=e.originalColumn-n.originalColumn,0!==r||o)?r:(r=e.generatedColumn-n.generatedColumn,0!==r)?r:(r=e.generatedLine-n.generatedLine,0===r?d(e.name,n.name):r):r},n.compareByGeneratedPositionsDeflated=/**
 * Comparator between two mappings with deflated source and name indices where
 * the generated positions are compared.
 *
 * Optionally pass in `true` as `onlyCompareGenerated` to consider two
 * mappings with the same generated line and column, but different
 * source/name/original line and column the same. Useful when searching for a
 * mapping with a stubbed out mapping.
 */function(e,n,o){var r=e.generatedLine-n.generatedLine;return 0===r?(r=e.generatedColumn-n.generatedColumn,0!==r||o)?r:(r=d(e.source,n.source),0!==r)?r:(r=e.originalLine-n.originalLine,0!==r)?r:(r=e.originalColumn-n.originalColumn,0===r?d(e.name,n.name):r):r},n.compareByGeneratedPositionsInflated=function(e,n){var o=e.generatedLine-n.generatedLine;return 0===o?(o=e.generatedColumn-n.generatedColumn,0!==o)?o:(o=d(e.source,n.source),0!==o)?o:(o=e.originalLine-n.originalLine,0!==o)?o:(o=e.originalColumn-n.originalColumn,0===o?d(e.name,n.name):o):o},n.parseSourceMapInput=/**
 * Strip any JSON XSSI avoidance prefix from the string (as documented
 * in the source maps specification), and then parse the string as
 * JSON.
 */function(e){return JSON.parse(e.replace(/^\)]}'[^\n]*\n/,""))},n.computeSourceURL=/**
 * Compute the URL of a source given the the source root, the source's
 * URL, and the source map's URL.
 */function(e,n,o){// Historically, SourceMapConsumer did not take the sourceMapURL as
// a parameter.  This mode is still somewhat supported, which is why
// this code block is conditional.  However, it's preferable to pass
// the source map URL to SourceMapConsumer, so that this function
// can implement the source URL resolution algorithm as outlined in
// the spec.  This block is basically the equivalent of:
//    new URL(sourceURL, sourceMapURL).toString()
// ... except it avoids using URL, which wasn't available in the
// older releases of node still supported by this library.
//
// The spec says:
//   If the sources are not absolute URLs after prepending of the
//   “sourceRoot”, the sources are resolved relative to the
//   SourceMap (like resolving script src in a html document).
if(n=n||"",e&&("/"!==e[e.length-1]&&"/"!==n[0]&&(e+="/"),n=e+n),o){var s=r(o);if(!s)throw new Error("sourceMapURL could not be parsed");if(s.path){// Strip the last path component, but keep the "/".
var u=s.path.lastIndexOf("/");0<=u&&(s.path=s.path.substring(0,u+1))}n=a(t(s),n)}return i(n)}}),util_1=util.getArg,util_2=util.urlParse,util_3=util.urlGenerate,util_4=util.normalize,util_5=util.join,util_6=util.isAbsolute,util_7=util.relative,util_8=util.toSetString,util_9=util.fromSetString,util_10=util.compareByOriginalPositions,util_11=util.compareByGeneratedPositionsDeflated,util_12=util.compareByGeneratedPositionsInflated,util_13=util.parseSourceMapInput,util_14=util.computeSourceURL,has=Object.prototype.hasOwnProperty,hasNativeMap="undefined"!=typeof Map;/**
 * A data structure which is a combination of an array and a set. Adding a new
 * member is O(1), testing for membership is O(1), and finding the index of an
 * element is O(1). Removing elements from the set is not supported. Only
 * strings are supported for membership.
 */function ArraySet(){this._array=[],this._set=hasNativeMap?new Map:Object.create(null)}/**
 * Static method for creating ArraySet instances from an existing array.
 */ArraySet.fromArray=function(e,n){for(var o=new ArraySet,r=0,t=e.length;r<t;r++)o.add(e[r],n);return o},ArraySet.prototype.size=function(){return hasNativeMap?this._set.size:Object.getOwnPropertyNames(this._set).length},ArraySet.prototype.add=function(e,n){var o=hasNativeMap?e:util.toSetString(e),r=hasNativeMap?this.has(e):has.call(this._set,o),t=this._array.length;(!r||n)&&this._array.push(e),r||(hasNativeMap?this._set.set(e,t):this._set[o]=t)},ArraySet.prototype.has=function(e){if(hasNativeMap)return this._set.has(e);var n=util.toSetString(e);return has.call(this._set,n)},ArraySet.prototype.indexOf=function(e){if(hasNativeMap){var n=this._set.get(e);if(0<=n)return n}else{var o=util.toSetString(e);if(has.call(this._set,o))return this._set[o]}throw new Error("\""+e+"\" is not in the set.")},ArraySet.prototype.at=function(e){if(0<=e&&e<this._array.length)return this._array[e];throw new Error("No element indexed by "+e)},ArraySet.prototype.toArray=function(){return this._array.slice()};var ArraySet_1=ArraySet,arraySet={ArraySet:ArraySet_1};/* -*- Mode: js; js-indent-level: 2; -*- */ /*
 * Copyright 2014 Mozilla Foundation and contributors
 * Licensed under the New BSD license. See LICENSE or:
 * http://opensource.org/licenses/BSD-3-Clause
 */ /**
 * Determine whether mappingB is after mappingA with respect to generated
 * position.
 */function generatedPositionAfter(e,n){// Optimized for most common case
var o=e.generatedLine,r=n.generatedLine,t=e.generatedColumn,i=n.generatedColumn;return r>o||r==o&&i>=t||0>=util.compareByGeneratedPositionsInflated(e,n)}/**
 * A data structure to provide a sorted view of accumulated mappings in a
 * performance conscious manner. It trades a neglibable overhead in general
 * case for a large speedup in case of mappings being added in order.
 */function MappingList(){// Serves as infimum
this._array=[],this._sorted=!0,this._last={generatedLine:-1,generatedColumn:0}}/**
 * Iterate through internal items. This method takes the same arguments that
 * `Array.prototype.forEach` takes.
 *
 * NOTE: The order of the mappings is NOT guaranteed.
 */MappingList.prototype.unsortedForEach=function(e,n){this._array.forEach(e,n)},MappingList.prototype.add=function(e){generatedPositionAfter(this._last,e)?(this._last=e,this._array.push(e)):(this._sorted=!1,this._array.push(e))},MappingList.prototype.toArray=function(){return this._sorted||(this._array.sort(util.compareByGeneratedPositionsInflated),this._sorted=!0),this._array};var MappingList_1=MappingList,mappingList={MappingList:MappingList_1},ArraySet$1=arraySet.ArraySet,MappingList$1=mappingList.MappingList;/**
 * An instance of the SourceMapGenerator represents a source map which is
 * being built incrementally. You may pass an object with the following
 * properties:
 *
 *   - file: The filename of the generated source.
 *   - sourceRoot: A root for all relative URLs in this source map.
 */function SourceMapGenerator(e){e||(e={}),this._file=util.getArg(e,"file",null),this._sourceRoot=util.getArg(e,"sourceRoot",null),this._skipValidation=util.getArg(e,"skipValidation",!1),this._sources=new ArraySet$1,this._names=new ArraySet$1,this._mappings=new MappingList$1,this._sourcesContents=null}SourceMapGenerator.prototype._version=3,SourceMapGenerator.fromSourceMap=function(e){var n=e.sourceRoot,o=new SourceMapGenerator({file:e.file,sourceRoot:n});return e.eachMapping(function(e){var r={generated:{line:e.generatedLine,column:e.generatedColumn}};null!=e.source&&(r.source=e.source,null!=n&&(r.source=util.relative(n,r.source)),r.original={line:e.originalLine,column:e.originalColumn},null!=e.name&&(r.name=e.name)),o.addMapping(r)}),e.sources.forEach(function(r){var t=r;null!==n&&(t=util.relative(n,r)),o._sources.has(t)||o._sources.add(t);var i=e.sourceContentFor(r);null!=i&&o.setSourceContent(r,i)}),o},SourceMapGenerator.prototype.addMapping=function(e){var n=util.getArg(e,"generated"),o=util.getArg(e,"original",null),r=util.getArg(e,"source",null),t=util.getArg(e,"name",null);this._skipValidation||this._validateMapping(n,o,r,t),null!=r&&(r=r+"",!this._sources.has(r)&&this._sources.add(r)),null!=t&&(t=t+"",!this._names.has(t)&&this._names.add(t)),this._mappings.add({generatedLine:n.line,generatedColumn:n.column,originalLine:null!=o&&o.line,originalColumn:null!=o&&o.column,source:r,name:t})},SourceMapGenerator.prototype.setSourceContent=function(e,n){var o=e;null!=this._sourceRoot&&(o=util.relative(this._sourceRoot,o)),null==n?this._sourcesContents&&(delete this._sourcesContents[util.toSetString(o)],0===Object.keys(this._sourcesContents).length&&(this._sourcesContents=null)):(!this._sourcesContents&&(this._sourcesContents=Object.create(null)),this._sourcesContents[util.toSetString(o)]=n)},SourceMapGenerator.prototype.applySourceMap=function(e,n,o){var r=n;// If aSourceFile is omitted, we will use the file property of the SourceMap
if(null==n){if(null==e.file)throw new Error("SourceMapGenerator.prototype.applySourceMap requires either an explicit source file, or the source map's \"file\" property. Both were omitted.");r=e.file}var t=this._sourceRoot;// Make "sourceFile" relative if an absolute Url is passed.
null!=t&&(r=util.relative(t,r));// Applying the SourceMap can add and remove items from the sources and
// the names array.
var i=new ArraySet$1,a=new ArraySet$1;// Find mappings for the "sourceFile"
// Copy sourcesContents of applied map.
this._mappings.unsortedForEach(function(n){if(n.source===r&&null!=n.originalLine){// Check if it can be mapped by the source map, then update the mapping.
var s=e.originalPositionFor({line:n.originalLine,column:n.originalColumn});null!=s.source&&(n.source=s.source,null!=o&&(n.source=util.join(o,n.source)),null!=t&&(n.source=util.relative(t,n.source)),n.originalLine=s.line,n.originalColumn=s.column,null!=s.name&&(n.name=s.name))}var u=n.source;null==u||i.has(u)||i.add(u);var d=n.name;null==d||a.has(d)||a.add(d)},this),this._sources=i,this._names=a,e.sources.forEach(function(n){var r=e.sourceContentFor(n);null!=r&&(null!=o&&(n=util.join(o,n)),null!=t&&(n=util.relative(t,n)),this.setSourceContent(n,r))},this)},SourceMapGenerator.prototype._validateMapping=function(e,n,o,r){// When aOriginal is truthy but has empty values for .line and .column,
// it is most likely a programmer error. In this case we throw a very
// specific error message to try to guide them the right way.
// For example: https://github.com/Polymer/polymer-bundler/pull/519
if(n&&"number"!=typeof n.line&&"number"!=typeof n.column)throw new Error("original.line and original.column are not numbers -- you probably meant to omit the original mapping entirely and only map the generated position. If so, pass null for the original mapping instead of an object with empty or null values.");if(!(e&&"line"in e&&"column"in e&&0<e.line&&0<=e.column&&!n&&!o&&!r)&&!(e&&"line"in e&&"column"in e&&n&&"line"in n&&"column"in n&&0<e.line&&0<=e.column&&0<n.line&&0<=n.column&&o))// Cases 2 and 3.
// Case 1.
throw new Error("Invalid mapping: "+JSON.stringify({generated:e,source:o,original:n,name:r}))},SourceMapGenerator.prototype._serializeMappings=function(){for(var e,n,o,r,t=0,a=1,s=0,u=0,d=0,l=0,c="",g=this._mappings.toArray(),p=0,m=g.length;p<m;p++){if(n=g[p],e="",n.generatedLine!==a)for(t=0;n.generatedLine!==a;)e+=";",a++;else if(0<p){if(!util.compareByGeneratedPositionsInflated(n,g[p-1]))continue;e+=","}e+=base64Vlq.encode(n.generatedColumn-t),t=n.generatedColumn,null!=n.source&&(r=this._sources.indexOf(n.source),e+=base64Vlq.encode(r-l),l=r,e+=base64Vlq.encode(n.originalLine-1-u),u=n.originalLine-1,e+=base64Vlq.encode(n.originalColumn-s),s=n.originalColumn,null!=n.name&&(o=this._names.indexOf(n.name),e+=base64Vlq.encode(o-d),d=o)),c+=e}return c},SourceMapGenerator.prototype._generateSourcesContent=function(e,n){return e.map(function(e){if(!this._sourcesContents)return null;null!=n&&(e=util.relative(n,e));var o=util.toSetString(e);return Object.prototype.hasOwnProperty.call(this._sourcesContents,o)?this._sourcesContents[o]:null},this)},SourceMapGenerator.prototype.toJSON=function(){var e={version:this._version,sources:this._sources.toArray(),names:this._names.toArray(),mappings:this._serializeMappings()};return null!=this._file&&(e.file=this._file),null!=this._sourceRoot&&(e.sourceRoot=this._sourceRoot),this._sourcesContents&&(e.sourcesContent=this._generateSourcesContent(e.sources,e.sourceRoot)),e},SourceMapGenerator.prototype.toString=function(){return JSON.stringify(this.toJSON())};var SourceMapGenerator_1=SourceMapGenerator,sourceMapGenerator={SourceMapGenerator:SourceMapGenerator_1},binarySearch=createCommonjsModule(function(e,n){/**
 * Recursive implementation of binary search.
 *
 * @param aLow Indices here and lower do not contain the needle.
 * @param aHigh Indices here and higher do not contain the needle.
 * @param aNeedle The element being searched for.
 * @param aHaystack The non-empty array being searched.
 * @param aCompare Function which takes two elements and returns -1, 0, or 1.
 * @param aBias Either 'binarySearch.GREATEST_LOWER_BOUND' or
 *     'binarySearch.LEAST_UPPER_BOUND'. Specifies whether to return the
 *     closest element that is smaller than or greater than the one we are
 *     searching for, respectively, if the exact element cannot be found.
 */function o(e,r,t,i,a,s){// This function terminates when one of the following is true:
//
//   1. We find the exact element we are looking for.
//
//   2. We did not find the exact element, but we can return the index of
//      the next-closest element.
//
//   3. We did not find the exact element, and there is no next-closest
//      element than the one we are searching for, so we return -1.
var u=Math.floor((r-e)/2)+e,d=a(t,i[u],!0);return 0===d?u:0<d?1<r-u?o(u,r,t,i,a,s):s==n.LEAST_UPPER_BOUND?r<i.length?r:-1:u:1<u-e?o(e,u,t,i,a,s):s==n.LEAST_UPPER_BOUND?u:0>e?-1:e}/**
 * This is an implementation of binary search which will always try and return
 * the index of the closest element if there is no exact hit. This is because
 * mappings between original and generated line/col pairs are single points,
 * and there is an implicit region between each of them, so a miss just means
 * that you aren't on the very start of a region.
 *
 * @param aNeedle The element you are looking for.
 * @param aHaystack The array that is being searched.
 * @param aCompare A function which takes the needle and an element in the
 *     array and returns -1, 0, or 1 depending on whether the needle is less
 *     than, equal to, or greater than the element, respectively.
 * @param aBias Either 'binarySearch.GREATEST_LOWER_BOUND' or
 *     'binarySearch.LEAST_UPPER_BOUND'. Specifies whether to return the
 *     closest element that is smaller than or greater than the one we are
 *     searching for, respectively, if the exact element cannot be found.
 *     Defaults to 'binarySearch.GREATEST_LOWER_BOUND'.
 */ /* -*- Mode: js; js-indent-level: 2; -*- */ /*
 * Copyright 2011 Mozilla Foundation and contributors
 * Licensed under the New BSD license. See LICENSE or:
 * http://opensource.org/licenses/BSD-3-Clause
 */n.GREATEST_LOWER_BOUND=1,n.LEAST_UPPER_BOUND=2,n.search=function(e,r,t,i){if(0===r.length)return-1;var a=o(-1,r.length,e,r,t,i||n.GREATEST_LOWER_BOUND);if(0>a)return-1;// We have found either the exact element, or the next-closest element than
// the one we are searching for. However, there may be more than one such
// element. Make sure we always return the smallest of these.
for(;0<=a-1&&!(0!==t(r[a],r[a-1],!0));)--a;return a}}),binarySearch_1=binarySearch.GREATEST_LOWER_BOUND,binarySearch_2=binarySearch.LEAST_UPPER_BOUND,binarySearch_3=binarySearch.search;/* -*- Mode: js; js-indent-level: 2; -*- */ /*
 * Copyright 2011 Mozilla Foundation and contributors
 * Licensed under the New BSD license. See LICENSE or:
 * http://opensource.org/licenses/BSD-3-Clause
 */ // It turns out that some (most?) JavaScript engines don't self-host
// `Array.prototype.sort`. This makes sense because C++ will likely remain
// faster than JS when doing raw CPU-intensive sorting. However, when using a
// custom comparator function, calling back and forth between the VM's C++ and
// JIT'd JS is rather slow *and* loses JIT type information, resulting in
// worse generated code for the comparator function than would be optimal. In
// fact, when sorting with a comparator, these costs outweigh the benefits of
// sorting in C++. By using our own JS-implemented Quick Sort (below), we get
// a ~3500ms mean speed-up in `bench/bench.html`.
/**
 * Swap the elements indexed by `x` and `y` in the array `ary`.
 *
 * @param {Array} ary
 *        The array.
 * @param {Number} x
 *        The index of the first item.
 * @param {Number} y
 *        The index of the second item.
 */function swap(e,n,o){var r=e[n];e[n]=e[o],e[o]=r}/**
 * Returns a random integer within the range `low .. high` inclusive.
 *
 * @param {Number} low
 *        The lower bound on the range.
 * @param {Number} high
 *        The upper bound on the range.
 */function randomIntInRange(e,n){return Math.round(e+Math.random()*(n-e))}/**
 * The Quick Sort algorithm.
 *
 * @param {Array} ary
 *        An array to sort.
 * @param {function} comparator
 *        Function to use to compare two items.
 * @param {Number} p
 *        Start index of the array
 * @param {Number} r
 *        End index of the array
 */function doQuickSort(e,n,o,t){// If our lower bound is less than our upper bound, we (1) partition the
// array into two pieces and (2) recurse on each half. If it is not, this is
// the empty array and our base case.
if(o<t){// (1) Partitioning.
//
// The partitioning chooses a pivot between `p` and `r` and moves all
// elements that are less than or equal to the pivot to the before it, and
// all the elements that are greater than it after it. The effect is that
// once partition is done, the pivot is in the exact place it will be when
// the array is put in sorted order, and it will not need to be moved
// again. This runs in O(n) time.
// Always choose a random pivot so that an input array which is reverse
// sorted does not cause O(n^2) running time.
var r=randomIntInRange(o,t),a=o-1;swap(e,r,t);// Immediately after `j` is incremented in this loop, the following hold
// true:
//
//   * Every element in `ary[p .. i]` is less than or equal to the pivot.
//
//   * Every element in `ary[i+1 .. j-1]` is greater than the pivot.
for(var s=e[t],u=o;u<t;u++)0>=n(e[u],s)&&(a+=1,swap(e,a,u));swap(e,a+1,u);var d=a+1;// (2) Recurse on each half.
doQuickSort(e,n,o,d-1),doQuickSort(e,n,d+1,t)}}/**
 * Sort the given array in-place with the given comparator function.
 *
 * @param {Array} ary
 *        An array to sort.
 * @param {function} comparator
 *        Function to use to compare two items.
 */var quickSort_1=function(e,n){doQuickSort(e,n,0,e.length-1)},quickSort={quickSort:quickSort_1},ArraySet$2=arraySet.ArraySet,quickSort$1=quickSort.quickSort;function SourceMapConsumer(e,n){var o=e;return"string"==typeof e&&(o=util.parseSourceMapInput(e)),null==o.sections?new BasicSourceMapConsumer(o,n):new IndexedSourceMapConsumer(o,n)}SourceMapConsumer.fromSourceMap=function(e,n){return BasicSourceMapConsumer.fromSourceMap(e,n)},SourceMapConsumer.prototype._version=3,SourceMapConsumer.prototype.__generatedMappings=null,Object.defineProperty(SourceMapConsumer.prototype,"_generatedMappings",{configurable:!0,enumerable:!0,get:function(){return this.__generatedMappings||this._parseMappings(this._mappings,this.sourceRoot),this.__generatedMappings}}),SourceMapConsumer.prototype.__originalMappings=null,Object.defineProperty(SourceMapConsumer.prototype,"_originalMappings",{configurable:!0,enumerable:!0,get:function(){return this.__originalMappings||this._parseMappings(this._mappings,this.sourceRoot),this.__originalMappings}}),SourceMapConsumer.prototype._charIsMappingSeparator=function(e,n){var o=e.charAt(n);return";"===o||","===o},SourceMapConsumer.prototype._parseMappings=function(){throw new Error("Subclasses must implement _parseMappings")},SourceMapConsumer.GENERATED_ORDER=1,SourceMapConsumer.ORIGINAL_ORDER=2,SourceMapConsumer.GREATEST_LOWER_BOUND=1,SourceMapConsumer.LEAST_UPPER_BOUND=2,SourceMapConsumer.prototype.eachMapping=function(e,n,o){var r,t=o||SourceMapConsumer.GENERATED_ORDER;switch(t){case SourceMapConsumer.GENERATED_ORDER:r=this._generatedMappings;break;case SourceMapConsumer.ORIGINAL_ORDER:r=this._originalMappings;break;default:throw new Error("Unknown order of iteration.");}var i=this.sourceRoot;r.map(function(e){var n=null===e.source?null:this._sources.at(e.source);return n=util.computeSourceURL(i,n,this._sourceMapURL),{source:n,generatedLine:e.generatedLine,generatedColumn:e.generatedColumn,originalLine:e.originalLine,originalColumn:e.originalColumn,name:null===e.name?null:this._names.at(e.name)}},this).forEach(e,n||null)},SourceMapConsumer.prototype.allGeneratedPositionsFor=function(e){var n=util.getArg(e,"line"),o={source:util.getArg(e,"source"),originalLine:n,originalColumn:util.getArg(e,"column",0)};// When there is no exact match, BasicSourceMapConsumer.prototype._findMapping
// returns the index of the closest mapping less than the needle. By
// setting needle.originalColumn to 0, we thus find the last mapping for
// the given line, provided such a mapping exists.
if(o.source=this._findSourceIndex(o.source),0>o.source)return[];var r=[],t=this._findMapping(o,this._originalMappings,"originalLine","originalColumn",util.compareByOriginalPositions,binarySearch.LEAST_UPPER_BOUND);if(0<=t){var i=this._originalMappings[t];if(void 0===e.column)// Iterate until either we run out of mappings, or we run into
// a mapping for a different line than the one we found. Since
// mappings are sorted, this is guaranteed to find all mappings for
// the line we found.
for(var a=i.originalLine;i&&i.originalLine===a;)r.push({line:util.getArg(i,"generatedLine",null),column:util.getArg(i,"generatedColumn",null),lastColumn:util.getArg(i,"lastGeneratedColumn",null)}),i=this._originalMappings[++t];else// Iterate until either we run out of mappings, or we run into
// a mapping for a different line than the one we were searching for.
// Since mappings are sorted, this is guaranteed to find all mappings for
// the line we are searching for.
for(var s=i.originalColumn;i&&i.originalLine===n&&i.originalColumn==s;)r.push({line:util.getArg(i,"generatedLine",null),column:util.getArg(i,"generatedColumn",null),lastColumn:util.getArg(i,"lastGeneratedColumn",null)}),i=this._originalMappings[++t]}return r};var SourceMapConsumer_1=SourceMapConsumer;/**
 * A BasicSourceMapConsumer instance represents a parsed source map which we can
 * query for information about the original file positions by giving it a file
 * position in the generated source.
 *
 * The first parameter is the raw source map (either as a JSON string, or
 * already parsed to an object). According to the spec, source maps have the
 * following attributes:
 *
 *   - version: Which version of the source map spec this map is following.
 *   - sources: An array of URLs to the original source files.
 *   - names: An array of identifiers which can be referrenced by individual mappings.
 *   - sourceRoot: Optional. The URL root from which all sources are relative.
 *   - sourcesContent: Optional. An array of contents of the original source files.
 *   - mappings: A string of base64 VLQs which contain the actual mappings.
 *   - file: Optional. The generated file this source map is associated with.
 *
 * Here is an example source map, taken from the source map spec[0]:
 *
 *     {
 *       version : 3,
 *       file: "out.js",
 *       sourceRoot : "",
 *       sources: ["foo.js", "bar.js"],
 *       names: ["src", "maps", "are", "fun"],
 *       mappings: "AA,AB;;ABCDE;"
 *     }
 *
 * The second parameter, if given, is a string whose value is the URL
 * at which the source map was found.  This URL is used to compute the
 * sources array.
 *
 * [0]: https://docs.google.com/document/d/1U1RGAehQwRypUTovF1KRlpiOFze0b-_2gc6fAH0KY0k/edit?pli=1#
 */function BasicSourceMapConsumer(e,n){var o=e;"string"==typeof e&&(o=util.parseSourceMapInput(e));var r=util.getArg(o,"version"),t=util.getArg(o,"sources"),i=util.getArg(o,"names",[]),a=util.getArg(o,"sourceRoot",null),s=util.getArg(o,"sourcesContent",null),u=util.getArg(o,"mappings"),d=util.getArg(o,"file",null);// Once again, Sass deviates from the spec and supplies the version as a
// string rather than a number, so we use loose equality checking here.
if(r!=this._version)throw new Error("Unsupported version: "+r);// Pass `true` below to allow duplicate names and sources. While source maps
// are intended to be compressed and deduplicated, the TypeScript compiler
// sometimes generates source maps with duplicates in them. See Github issue
// #72 and bugzil.la/889492.
a&&(a=util.normalize(a)),t=t.map(String)// Some source maps produce relative source paths like "./foo.js" instead of
// "foo.js".  Normalize these first so that future comparisons will succeed.
// See bugzil.la/1090768.
.map(util.normalize)// Always ensure that absolute sources are internally stored relative to
// the source root, if the source root is absolute. Not doing this would
// be particularly problematic when the source root is a prefix of the
// source (valid, but why??). See github issue #199 and bugzil.la/1188982.
.map(function(e){return a&&util.isAbsolute(a)&&util.isAbsolute(e)?util.relative(a,e):e}),this._names=ArraySet$2.fromArray(i.map(String),!0),this._sources=ArraySet$2.fromArray(t,!0),this._absoluteSources=this._sources.toArray().map(function(e){return util.computeSourceURL(a,e,n)}),this.sourceRoot=a,this.sourcesContent=s,this._mappings=u,this._sourceMapURL=n,this.file=d}BasicSourceMapConsumer.prototype=Object.create(SourceMapConsumer.prototype),BasicSourceMapConsumer.prototype.consumer=SourceMapConsumer,BasicSourceMapConsumer.prototype._findSourceIndex=function(e){var n=e;if(null!=this.sourceRoot&&(n=util.relative(this.sourceRoot,n)),this._sources.has(n))return this._sources.indexOf(n);// Maybe aSource is an absolute URL as returned by |sources|.  In
// this case we can't simply undo the transform.
var o;for(o=0;o<this._absoluteSources.length;++o)if(this._absoluteSources[o]==e)return o;return-1},BasicSourceMapConsumer.fromSourceMap=function(e,n){var o=Object.create(BasicSourceMapConsumer.prototype),r=o._names=ArraySet$2.fromArray(e._names.toArray(),!0),t=o._sources=ArraySet$2.fromArray(e._sources.toArray(),!0);o.sourceRoot=e._sourceRoot,o.sourcesContent=e._generateSourcesContent(o._sources.toArray(),o.sourceRoot),o.file=e._file,o._sourceMapURL=n,o._absoluteSources=o._sources.toArray().map(function(e){return util.computeSourceURL(o.sourceRoot,e,n)});for(var a=e._mappings.toArray().slice(),s=o.__generatedMappings=[],u=o.__originalMappings=[],d=0,l=a.length;d<l;d++){var c=a[d],g=new Mapping;g.generatedLine=c.generatedLine,g.generatedColumn=c.generatedColumn,c.source&&(g.source=t.indexOf(c.source),g.originalLine=c.originalLine,g.originalColumn=c.originalColumn,c.name&&(g.name=r.indexOf(c.name)),u.push(g)),s.push(g)}return quickSort$1(o.__originalMappings,util.compareByOriginalPositions),o},BasicSourceMapConsumer.prototype._version=3,Object.defineProperty(BasicSourceMapConsumer.prototype,"sources",{get:function(){return this._absoluteSources.slice()}});/**
 * Provide the JIT with a nice shape / hidden class.
 */function Mapping(){this.generatedLine=0,this.generatedColumn=0,this.source=null,this.originalLine=null,this.originalColumn=null,this.name=null}/**
 * Parse the mappings in a string in to a data structure which we can easily
 * query (the ordered arrays in the `this.__generatedMappings` and
 * `this.__originalMappings` properties).
 */BasicSourceMapConsumer.prototype._parseMappings=function(e){for(var n,o,r,t,i,a=1,s=0,u=0,d=0,l=0,c=0,g=e.length,p=0,m={},f={},_=[],h=[];p<g;)if(";"===e.charAt(p))a++,p++,s=0;else if(","===e.charAt(p))p++;else{// Because each offset is encoded relative to the previous one,
// many segments often have the same encoding. We can exploit this
// fact by caching the parsed variable length fields of each segment,
// allowing us to avoid a second parse if we encounter the same
// segment again.
for(n=new Mapping,n.generatedLine=a,t=p;t<g&&!this._charIsMappingSeparator(e,t);t++);if(o=e.slice(p,t),r=m[o],r)p+=o.length;else{for(r=[];p<t;)base64Vlq.decode(e,p,f),i=f.value,p=f.rest,r.push(i);if(2===r.length)throw new Error("Found a source, but no line and column");if(3===r.length)throw new Error("Found a source and line, but no column");m[o]=r}// Generated column.
n.generatedColumn=s+r[0],s=n.generatedColumn,1<r.length&&(n.source=l+r[1],l+=r[1],n.originalLine=u+r[2],u=n.originalLine,n.originalLine+=1,n.originalColumn=d+r[3],d=n.originalColumn,4<r.length&&(n.name=c+r[4],c+=r[4])),h.push(n),"number"==typeof n.originalLine&&_.push(n)}quickSort$1(h,util.compareByGeneratedPositionsDeflated),this.__generatedMappings=h,quickSort$1(_,util.compareByOriginalPositions),this.__originalMappings=_},BasicSourceMapConsumer.prototype._findMapping=function(e,n,o,r,t,i){// To return the position we are searching for, we must first find the
// mapping for the given position and then return the opposite position it
// points to. Because the mappings are sorted, we can use binary search to
// find the best mapping.
if(0>=e[o])throw new TypeError("Line must be greater than or equal to 1, got "+e[o]);if(0>e[r])throw new TypeError("Column must be greater than or equal to 0, got "+e[r]);return binarySearch.search(e,n,t,i)},BasicSourceMapConsumer.prototype.computeColumnSpans=function(){for(var e,n=0;n<this._generatedMappings.length;++n){// Mappings do not contain a field for the last generated columnt. We
// can come up with an optimistic estimate, however, by assuming that
// mappings are contiguous (i.e. given two consecutive mappings, the
// first mapping ends where the second one starts).
if(e=this._generatedMappings[n],n+1<this._generatedMappings.length){var o=this._generatedMappings[n+1];if(e.generatedLine===o.generatedLine){e.lastGeneratedColumn=o.generatedColumn-1;continue}}// The last mapping for each line spans the entire line.
e.lastGeneratedColumn=1/0}},BasicSourceMapConsumer.prototype.originalPositionFor=function(e){var n={generatedLine:util.getArg(e,"line"),generatedColumn:util.getArg(e,"column")},o=this._findMapping(n,this._generatedMappings,"generatedLine","generatedColumn",util.compareByGeneratedPositionsDeflated,util.getArg(e,"bias",SourceMapConsumer.GREATEST_LOWER_BOUND));if(0<=o){var r=this._generatedMappings[o];if(r.generatedLine===n.generatedLine){var t=util.getArg(r,"source",null);null!==t&&(t=this._sources.at(t),t=util.computeSourceURL(this.sourceRoot,t,this._sourceMapURL));var i=util.getArg(r,"name",null);return null!==i&&(i=this._names.at(i)),{source:t,line:util.getArg(r,"originalLine",null),column:util.getArg(r,"originalColumn",null),name:i}}}return{source:null,line:null,column:null,name:null}},BasicSourceMapConsumer.prototype.hasContentsOfAllSources=function(){return!!this.sourcesContent&&this.sourcesContent.length>=this._sources.size()&&!this.sourcesContent.some(function(e){return null==e})},BasicSourceMapConsumer.prototype.sourceContentFor=function(e,n){if(!this.sourcesContent)return null;var o=this._findSourceIndex(e);if(0<=o)return this.sourcesContent[o];var r=e;null!=this.sourceRoot&&(r=util.relative(this.sourceRoot,r));var t;if(null!=this.sourceRoot&&(t=util.urlParse(this.sourceRoot))){// XXX: file:// URIs and absolute paths lead to unexpected behavior for
// many users. We can help them out when they expect file:// URIs to
// behave like it would if they were running a local HTTP server. See
// https://bugzilla.mozilla.org/show_bug.cgi?id=885597.
var i=r.replace(/^file:\/\//,"");if("file"==t.scheme&&this._sources.has(i))return this.sourcesContent[this._sources.indexOf(i)];if((!t.path||"/"==t.path)&&this._sources.has("/"+r))return this.sourcesContent[this._sources.indexOf("/"+r)]}// This function is used recursively from
// IndexedSourceMapConsumer.prototype.sourceContentFor. In that case, we
// don't want to throw if we can't find the source - we just want to
// return null, so we provide a flag to exit gracefully.
if(n)return null;throw new Error("\""+r+"\" is not in the SourceMap.")},BasicSourceMapConsumer.prototype.generatedPositionFor=function(e){var n=util.getArg(e,"source");if(n=this._findSourceIndex(n),0>n)return{line:null,column:null,lastColumn:null};var o={source:n,originalLine:util.getArg(e,"line"),originalColumn:util.getArg(e,"column")},r=this._findMapping(o,this._originalMappings,"originalLine","originalColumn",util.compareByOriginalPositions,util.getArg(e,"bias",SourceMapConsumer.GREATEST_LOWER_BOUND));if(0<=r){var t=this._originalMappings[r];if(t.source===o.source)return{line:util.getArg(t,"generatedLine",null),column:util.getArg(t,"generatedColumn",null),lastColumn:util.getArg(t,"lastGeneratedColumn",null)}}return{line:null,column:null,lastColumn:null}};var BasicSourceMapConsumer_1=BasicSourceMapConsumer;/**
 * An IndexedSourceMapConsumer instance represents a parsed source map which
 * we can query for information. It differs from BasicSourceMapConsumer in
 * that it takes "indexed" source maps (i.e. ones with a "sections" field) as
 * input.
 *
 * The first parameter is a raw source map (either as a JSON string, or already
 * parsed to an object). According to the spec for indexed source maps, they
 * have the following attributes:
 *
 *   - version: Which version of the source map spec this map is following.
 *   - file: Optional. The generated file this source map is associated with.
 *   - sections: A list of section definitions.
 *
 * Each value under the "sections" field has two fields:
 *   - offset: The offset into the original specified at which this section
 *       begins to apply, defined as an object with a "line" and "column"
 *       field.
 *   - map: A source map definition. This source map could also be indexed,
 *       but doesn't have to be.
 *
 * Instead of the "map" field, it's also possible to have a "url" field
 * specifying a URL to retrieve a source map from, but that's currently
 * unsupported.
 *
 * Here's an example source map, taken from the source map spec[0], but
 * modified to omit a section which uses the "url" field.
 *
 *  {
 *    version : 3,
 *    file: "app.js",
 *    sections: [{
 *      offset: {line:100, column:10},
 *      map: {
 *        version : 3,
 *        file: "section.js",
 *        sources: ["foo.js", "bar.js"],
 *        names: ["src", "maps", "are", "fun"],
 *        mappings: "AAAA,E;;ABCDE;"
 *      }
 *    }],
 *  }
 *
 * The second parameter, if given, is a string whose value is the URL
 * at which the source map was found.  This URL is used to compute the
 * sources array.
 *
 * [0]: https://docs.google.com/document/d/1U1RGAehQwRypUTovF1KRlpiOFze0b-_2gc6fAH0KY0k/edit#heading=h.535es3xeprgt
 */function IndexedSourceMapConsumer(e,n){var o=e;"string"==typeof e&&(o=util.parseSourceMapInput(e));var r=util.getArg(o,"version"),t=util.getArg(o,"sections");if(r!=this._version)throw new Error("Unsupported version: "+r);this._sources=new ArraySet$2,this._names=new ArraySet$2;var i={line:-1,column:0};this._sections=t.map(function(e){if(e.url)// The url field will require support for asynchronicity.
// See https://github.com/mozilla/source-map/issues/16
throw new Error("Support for url field in sections not implemented.");var o=util.getArg(e,"offset"),r=util.getArg(o,"line"),t=util.getArg(o,"column");if(r<i.line||r===i.line&&t<i.column)throw new Error("Section offsets must be ordered and non-overlapping.");return i=o,{generatedOffset:{// The offset fields are 0-based, but we use 1-based indices when
// encoding/decoding from VLQ.
generatedLine:r+1,generatedColumn:t+1},consumer:new SourceMapConsumer(util.getArg(e,"map"),n)}})}IndexedSourceMapConsumer.prototype=Object.create(SourceMapConsumer.prototype),IndexedSourceMapConsumer.prototype.constructor=SourceMapConsumer,IndexedSourceMapConsumer.prototype._version=3,Object.defineProperty(IndexedSourceMapConsumer.prototype,"sources",{get:function(){for(var e=[],n=0;n<this._sections.length;n++)for(var o=0;o<this._sections[n].consumer.sources.length;o++)e.push(this._sections[n].consumer.sources[o]);return e}}),IndexedSourceMapConsumer.prototype.originalPositionFor=function(e){var n={generatedLine:util.getArg(e,"line"),generatedColumn:util.getArg(e,"column")},o=binarySearch.search(n,this._sections,function(e,n){var o=e.generatedLine-n.generatedOffset.generatedLine;return o?o:e.generatedColumn-n.generatedOffset.generatedColumn}),r=this._sections[o];// Find the section containing the generated position we're trying to map
// to an original position.
return r?r.consumer.originalPositionFor({line:n.generatedLine-(r.generatedOffset.generatedLine-1),column:n.generatedColumn-(r.generatedOffset.generatedLine===n.generatedLine?r.generatedOffset.generatedColumn-1:0),bias:e.bias}):{source:null,line:null,column:null,name:null}},IndexedSourceMapConsumer.prototype.hasContentsOfAllSources=function(){return this._sections.every(function(e){return e.consumer.hasContentsOfAllSources()})},IndexedSourceMapConsumer.prototype.sourceContentFor=function(e,n){for(var o=0;o<this._sections.length;o++){var r=this._sections[o],t=r.consumer.sourceContentFor(e,!0);if(t)return t}if(n)return null;throw new Error("\""+e+"\" is not in the SourceMap.")},IndexedSourceMapConsumer.prototype.generatedPositionFor=function(e){for(var n,o=0;o<this._sections.length;o++)// Only consider this section if the requested source is in the list of
// sources of the consumer.
if(n=this._sections[o],-1!==n.consumer._findSourceIndex(util.getArg(e,"source"))){var r=n.consumer.generatedPositionFor(e);if(r){var t={line:r.line+(n.generatedOffset.generatedLine-1),column:r.column+(n.generatedOffset.generatedLine===r.line?n.generatedOffset.generatedColumn-1:0)};return t}}return{line:null,column:null}},IndexedSourceMapConsumer.prototype._parseMappings=function(){this.__generatedMappings=[],this.__originalMappings=[];for(var e=0;e<this._sections.length;e++)for(var n=this._sections[e],o=n.consumer._generatedMappings,r=0;r<o.length;r++){var t=o[r],a=n.consumer._sources.at(t.source);a=util.computeSourceURL(n.consumer.sourceRoot,a,this._sourceMapURL),this._sources.add(a),a=this._sources.indexOf(a);var s=null;t.name&&(s=n.consumer._names.at(t.name),this._names.add(s),s=this._names.indexOf(s));// The mappings coming from the consumer for the section have
// generated positions relative to the start of the section, so we
// need to offset them to be relative to the start of the concatenated
// generated file.
var u={source:a,generatedLine:t.generatedLine+(n.generatedOffset.generatedLine-1),generatedColumn:t.generatedColumn+(n.generatedOffset.generatedLine===t.generatedLine?n.generatedOffset.generatedColumn-1:0),originalLine:t.originalLine,originalColumn:t.originalColumn,name:s};this.__generatedMappings.push(u),"number"==typeof u.originalLine&&this.__originalMappings.push(u)}quickSort$1(this.__generatedMappings,util.compareByGeneratedPositionsDeflated),quickSort$1(this.__originalMappings,util.compareByOriginalPositions)};var IndexedSourceMapConsumer_1=IndexedSourceMapConsumer,sourceMapConsumer={SourceMapConsumer:SourceMapConsumer_1,BasicSourceMapConsumer:BasicSourceMapConsumer_1,IndexedSourceMapConsumer:IndexedSourceMapConsumer_1},SourceMapGenerator$1=sourceMapGenerator.SourceMapGenerator,REGEX_NEWLINE=/(\r?\n)/,NEWLINE_CODE=10,isSourceNode="$$$isSourceNode$$$";/**
 * SourceNodes provide a way to abstract over interpolating/concatenating
 * snippets of generated JavaScript source code while maintaining the line and
 * column information associated with the original source code.
 *
 * @param aLine The original line number.
 * @param aColumn The original column number.
 * @param aSource The original source's filename.
 * @param aChunks Optional. An array of strings which are snippets of
 *        generated JS, or other SourceNodes.
 * @param aName The original identifier.
 */function SourceNode(e,n,o,r,t){this.children=[],this.sourceContents={},this.line=null==e?null:e,this.column=null==n?null:n,this.source=null==o?null:o,this.name=null==t?null:t,this[isSourceNode]=!0,null!=r&&this.add(r)}/**
 * Creates a SourceNode from generated code and a SourceMapConsumer.
 *
 * @param aGeneratedCode The generated code
 * @param aSourceMapConsumer The SourceMap for the generated code
 * @param aRelativePath Optional. The path that relative sources in the
 *        SourceMapConsumer should be relative to.
 */SourceNode.fromStringWithSourceMap=function(e,n,o){function r(e,n){if(null===e||void 0===e.source)t.add(n);else{var r=o?util.join(o,e.source):e.source;t.add(new SourceNode(e.originalLine,e.originalColumn,r,n,e.name))}}// The SourceNode we want to fill with the generated code
// and the SourceMap
var t=new SourceNode,i=e.split(REGEX_NEWLINE),a=0,s=function(){function e(){return a<i.length?i[a++]:void 0}var n=e(),o=e()||"";// The last line of a file might not have a newline.
return n+o},u=1,d=0,l=null;// All even indices of this array are one line of the generated code,
// while all odd indices are the newlines between two adjacent lines
// (since `REGEX_NEWLINE` captures its match).
// Processed fragments are accessed by calling `shiftNextLine`.
return n.eachMapping(function(e){if(null!==l)// We add the code from "lastMapping" to "mapping":
// First check if there is a new line in between.
if(u<e.generatedLine)r(l,s()),u++,d=0;else{// There is no new line in between.
// Associate the code between "lastGeneratedColumn" and
// "mapping.generatedColumn" with "lastMapping"
var n=i[a]||"",o=n.substr(0,e.generatedColumn-d);return i[a]=n.substr(e.generatedColumn-d),d=e.generatedColumn,r(l,o),void(l=e)}// We add the generated code until the first mapping
// to the SourceNode without any mapping.
// Each line is added as separate string.
for(;u<e.generatedLine;)t.add(s()),u++;if(d<e.generatedColumn){var n=i[a]||"";t.add(n.substr(0,e.generatedColumn)),i[a]=n.substr(e.generatedColumn),d=e.generatedColumn}l=e},this),a<i.length&&(l&&r(l,s()),t.add(i.splice(a).join(""))),n.sources.forEach(function(e){var r=n.sourceContentFor(e);null!=r&&(null!=o&&(e=util.join(o,e)),t.setSourceContent(e,r))}),t},SourceNode.prototype.add=function(e){if(Array.isArray(e))e.forEach(function(e){this.add(e)},this);else if(e[isSourceNode]||"string"==typeof e)e&&this.children.push(e);else throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got "+e);return this},SourceNode.prototype.prepend=function(e){if(Array.isArray(e))for(var n=e.length-1;0<=n;n--)this.prepend(e[n]);else if(e[isSourceNode]||"string"==typeof e)this.children.unshift(e);else throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got "+e);return this},SourceNode.prototype.walk=function(e){for(var n,o=0,r=this.children.length;o<r;o++)n=this.children[o],n[isSourceNode]?n.walk(e):""!==n&&e(n,{source:this.source,line:this.line,column:this.column,name:this.name})},SourceNode.prototype.join=function(e){var n,o,r=this.children.length;if(0<r){for(n=[],o=0;o<r-1;o++)n.push(this.children[o]),n.push(e);n.push(this.children[o]),this.children=n}return this},SourceNode.prototype.replaceRight=function(e,n){var o=this.children[this.children.length-1];return o[isSourceNode]?o.replaceRight(e,n):"string"==typeof o?this.children[this.children.length-1]=o.replace(e,n):this.children.push("".replace(e,n)),this},SourceNode.prototype.setSourceContent=function(e,n){this.sourceContents[util.toSetString(e)]=n},SourceNode.prototype.walkSourceContents=function(e){for(var n=0,o=this.children.length;n<o;n++)this.children[n][isSourceNode]&&this.children[n].walkSourceContents(e);for(var r=Object.keys(this.sourceContents),n=0,o=r.length;n<o;n++)e(util.fromSetString(r[n]),this.sourceContents[r[n]])},SourceNode.prototype.toString=function(){var e="";return this.walk(function(n){e+=n}),e},SourceNode.prototype.toStringWithSourceMap=function(e){var n={code:"",line:1,column:0},o=new SourceMapGenerator$1(e),r=!1,t=null,i=null,a=null,s=null;return this.walk(function(e,u){n.code+=e,null!==u.source&&null!==u.line&&null!==u.column?((t!==u.source||i!==u.line||a!==u.column||s!==u.name)&&o.addMapping({source:u.source,original:{line:u.line,column:u.column},generated:{line:n.line,column:n.column},name:u.name}),t=u.source,i=u.line,a=u.column,s=u.name,r=!0):r&&(o.addMapping({generated:{line:n.line,column:n.column}}),t=null,r=!1);for(var d=0,l=e.length;d<l;d++)e.charCodeAt(d)===NEWLINE_CODE?(n.line++,n.column=0,d+1===l?(t=null,r=!1):r&&o.addMapping({source:u.source,original:{line:u.line,column:u.column},generated:{line:n.line,column:n.column},name:u.name})):n.column++}),this.walkSourceContents(function(e,n){o.setSourceContent(e,n)}),{code:n.code,map:o}};var SourceNode_1=SourceNode,sourceNode={SourceNode:SourceNode_1},SourceMapGenerator$2=sourceMapGenerator.SourceMapGenerator,SourceMapConsumer$1=sourceMapConsumer.SourceMapConsumer,SourceNode$1=sourceNode.SourceNode,sourceMap={SourceMapGenerator:SourceMapGenerator$2,SourceMapConsumer:SourceMapConsumer$1,SourceNode:SourceNode$1};// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.
// resolves . and .. elements in a path array with directory names there
// must be no slashes, empty elements, or device names (c:\) in the array
// (so also no leading and trailing slashes - it does not distinguish
// relative and absolute paths)
function normalizeArray(e,n){// if the path tries to go above the root, `up` ends up > 0
for(var o,r=0,t=e.length-1;0<=t;t--)o=e[t],"."===o?e.splice(t,1):".."===o?(e.splice(t,1),r++):r&&(e.splice(t,1),r--);// if the path is allowed to go above the root, restore leading ..s
if(n)for(;r--;r)e.unshift("..");return e}// Split a filename into [root, dir, basename, ext], unix version
// 'root' is just a slash, or nothing.
var splitPathRe=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/,splitPath=function(e){return splitPathRe.exec(e).slice(1)};// path.resolve([from ...], to)
// posix version
function resolve(){for(var e,n="",o=!1,r=arguments.length-1;-1<=r&&!o;r--){// Skip empty and invalid entries
if(e=0<=r?arguments[r]:"/","string"!=typeof e)throw new TypeError("Arguments to path.resolve must be strings");else if(!e)continue;n=e+"/"+n,o="/"===e.charAt(0)}// At this point the path should be resolved to a full absolute path, but
// handle relative paths to be safe (might happen when process.cwd() fails)
// Normalize the path
return n=normalizeArray(filter(n.split("/"),function(e){return!!e}),!o).join("/"),(o?"/":"")+n||"."}// path.normalize(path)
// posix version
function normalize(e){var n=isAbsolute(e),o="/"===substr(e,-1);// Normalize the path
return e=normalizeArray(filter(e.split("/"),function(e){return!!e}),!n).join("/"),e||n||(e="."),e&&o&&(e+="/"),(n?"/":"")+e}// posix version
function isAbsolute(e){return"/"===e.charAt(0)}// posix version
function join(){var e=Array.prototype.slice.call(arguments,0);return normalize(filter(e,function(e){if("string"!=typeof e)throw new TypeError("Arguments to path.join must be strings");return e}).join("/"))}// path.relative(from, to)
// posix version
function relative(e,n){var r=Math.min;function o(e){for(var n=0;n<e.length&&""===e[n];n++);for(var o=e.length-1;0<=o&&""===e[o];o--);return n>o?[]:e.slice(n,o-n+1)}e=resolve(e).substr(1),n=resolve(n).substr(1);for(var t=o(e.split("/")),a=o(n.split("/")),s=r(t.length,a.length),u=s,d=0;d<s;d++)if(t[d]!==a[d]){u=d;break}for(var l=[],d=u;d<t.length;d++)l.push("..");return l=l.concat(a.slice(u)),l.join("/")}var sep="/",delimiter=":";function dirname(e){var n=splitPath(e),o=n[0],r=n[1];return o||r?(r&&(r=r.substr(0,r.length-1)),o+r):"."}function basename(e,n){var o=splitPath(e)[2];// TODO: make this comparison case-insensitive on windows?
return n&&o.substr(-1*n.length)===n&&(o=o.substr(0,o.length-n.length)),o}function extname(e){return splitPath(e)[3]}var require$$1={extname:extname,basename:basename,dirname:dirname,sep:"/",delimiter:delimiter,relative:relative,join:join,isAbsolute:isAbsolute,normalize:normalize,resolve:resolve};function filter(e,n){if(e.filter)return e.filter(n);for(var o=[],r=0;r<e.length;r++)n(e[r],r,e)&&o.push(e[r]);return o}// String.prototype.substr - negative index don't work in IE8
var substr=function(e,n,o){return e.substr(n,o)},require$$3={},toString=Object.prototype.toString,isModern="function"==typeof Buffer.alloc&&"function"==typeof Buffer.allocUnsafe&&"function"==typeof Buffer.from;function isArrayBuffer(e){return"ArrayBuffer"===toString.call(e).slice(8,-1)}function fromArrayBuffer(e,n,o){n>>>=0;var r=e.byteLength-n;if(0>r)throw new RangeError("'offset' is out of bounds");if(void 0===o)o=r;else if(o>>>=0,o>r)throw new RangeError("'length' is out of bounds");return isModern?Buffer.from(e.slice(n,n+o)):new Buffer(new Uint8Array(e.slice(n,n+o)))}function fromString(e,n){if(("string"!=typeof n||""===n)&&(n="utf8"),!Buffer.isEncoding(n))throw new TypeError("\"encoding\" must be a valid string encoding");return isModern?Buffer.from(e,n):new Buffer(e,n)}function bufferFrom(e,n,o){if("number"==typeof e)throw new TypeError("\"value\" argument must not be a number");return isArrayBuffer(e)?fromArrayBuffer(e,n,o):"string"==typeof e?fromString(e,n):isModern?Buffer.from(e):new Buffer(e)}var fs,bufferFrom_1=bufferFrom,SourceMapConsumer$2=sourceMap.SourceMapConsumer,path=require$$1;try{fs=require$$3,fs.existsSync&&fs.readFileSync||(fs=null)}catch(e){}/* nop */ // Only install once if called multiple times
var errorFormatterInstalled=!1,uncaughtShimInstalled=!1,emptyCacheBetweenOperations=!1,environment="auto",fileContentsCache={},sourceMapCache={},reSourceMap=/^data:application\/json[^,]+base64,/,retrieveFileHandlers=[],retrieveMapHandlers=[];function isInBrowser(){return!("browser"!==environment)||"node"!==environment&&"undefined"!=typeof window&&"function"==typeof XMLHttpRequest&&!(window.require&&window.module&&window.process&&"renderer"===window.process.type)}function hasGlobalProcessEventEmitter(){return"object"==typeof process&&null!==process&&"function"==typeof process.on}function handlerExec(e){return function(n){for(var o,r=0;r<e.length;r++)if(o=e[r](n),o)return o;return null}}var retrieveFile=handlerExec(retrieveFileHandlers);retrieveFileHandlers.push(function(e){if(e=e.trim(),/^file:/.test(e)&&(e=e.replace(/file:\/\/\/(\w:)?/,function(e,n){return n?"":// file:///C:/dir/file -> C:/dir/file
"/";// file:///root-dir/file -> /root-dir/file
})),e in fileContentsCache)return fileContentsCache[e];var n="";try{if(!fs){// Use SJAX if we are in the browser
var o=new XMLHttpRequest;o.open("GET",e,!1),o.send(null),4===o.readyState&&200===o.status&&(n=o.responseText)}else fs.existsSync(e)&&(// Otherwise, use the filesystem
n=fs.readFileSync(e,"utf8"))}catch(e){/* ignore any errors */}return fileContentsCache[e]=n});// Support URLs relative to a directory, but be careful about a protocol prefix
// in case we are in the browser (i.e. directories may start with "http://" or "file:///")
function supportRelativeURL(e,n){if(!e)return n;var o=path.dirname(e),r=/^\w+:\/\/[^\/]*/.exec(o),t=r?r[0]:"",i=o.slice(t.length);return t&&/^\/\w\:/.test(i)?(t+="/",t+path.resolve(o.slice(t.length),n).replace(/\\/g,"/")):t+path.resolve(o.slice(t.length),n)}function retrieveSourceMapURL(e){var n;if(isInBrowser())try{var o=new XMLHttpRequest;o.open("GET",e,!1),o.send(null),n=4===o.readyState?o.responseText:null;// Support providing a sourceMappingURL via the SourceMap header
var r=o.getResponseHeader("SourceMap")||o.getResponseHeader("X-SourceMap");if(r)return r}catch(n){}// Get the URL of the source map
n=retrieveFile(e);for(var t,i,a=/(?:\/\/[@#][ \t]+sourceMappingURL=([^\s'"]+?)[ \t]*$)|(?:\/\*[@#][ \t]+sourceMappingURL=([^\*]+?)[ \t]*(?:\*\/)[ \t]*$)/mg// Keep executing the search to find the *last* sourceMappingURL to avoid
// picking up sourceMappingURLs from comments, strings, etc.
;i=a.exec(n);)t=i;return t?t[1]:null}// Can be overridden by the retrieveSourceMap option to install. Takes a
// generated source filename; returns a {map, optional url} object, or null if
// there is no source map.  The map field may be either a string or the parsed
// JSON object (ie, it must be a valid argument to the SourceMapConsumer
// constructor).
var retrieveSourceMap=handlerExec(retrieveMapHandlers);retrieveMapHandlers.push(function(e){var n=retrieveSourceMapURL(e);if(!n)return null;// Read the contents of the source map
var o;if(reSourceMap.test(n)){// Support source map URL as a data url
var r=n.slice(n.indexOf(",")+1);o=bufferFrom_1(r,"base64").toString(),n=e}else// Support source map URLs relative to the source URL
n=supportRelativeURL(e,n),o=retrieveFile(n);return o?{url:n,map:o}:null});function mapSourcePosition(e){var n=sourceMapCache[e.source];if(!n){// Call the (overrideable) retrieveSourceMap function to get the source map.
var o=retrieveSourceMap(e.source);o?(n=sourceMapCache[e.source]={url:o.url,map:new SourceMapConsumer$2(o.map)},n.map.sourcesContent&&n.map.sources.forEach(function(e,o){var r=n.map.sourcesContent[o];if(r){var t=supportRelativeURL(n.url,e);fileContentsCache[t]=r}})):n=sourceMapCache[e.source]={url:null,map:null}}// Resolve the source URL relative to the URL of the source map
if(n&&n.map&&"function"==typeof n.map.originalPositionFor){var r=n.map.originalPositionFor(e);// Only return the original position if a matching line was found. If no
// matching line is found then we return position instead, which will cause
// the stack trace to print the path and line for the compiled file. It is
// better to give a precise location in the compiled file than a vague
// location in the original file.
if(null!==r.source)return r.source=supportRelativeURL(n.url,r.source),r}return e}// Parses code generated by FormatEvalOrigin(), a function inside V8:
// https://code.google.com/p/v8/source/browse/trunk/src/messages.js
function mapEvalOrigin(e){// Most eval() calls are in this format
var n=/^eval at ([^(]+) \((.+):(\d+):(\d+)\)$/.exec(e);if(n){var o=mapSourcePosition({source:n[2],line:+n[3],column:n[4]-1});return"eval at "+n[1]+" ("+o.source+":"+o.line+":"+(o.column+1)+")"}// Parse nested eval() calls using recursion
return n=/^eval at ([^(]+) \((.+)\)$/.exec(e),n?"eval at "+n[1]+" ("+mapEvalOrigin(n[2])+")":e;// Make sure we still return useful information if we didn't find anything
}// This is copied almost verbatim from the V8 source code at
// https://code.google.com/p/v8/source/browse/trunk/src/messages.js. The
// implementation of wrapCallSite() used to just forward to the actual source
// code of CallSite.prototype.toString but unfortunately a new release of V8
// did something to the prototype chain and broke the shim. The only fix I
// could find was copy/paste.
function CallSiteToString(){var e,n="";if(this.isNative())n="native";else{e=this.getScriptNameOrSourceURL(),!e&&this.isEval()&&(n=this.getEvalOrigin(),n+=", "),n+=e?e:"<anonymous>";var o=this.getLineNumber();if(null!=o){n+=":"+o;var r=this.getColumnNumber();r&&(n+=":"+r)}}var t="",i=this.getFunctionName(),a=!0,s=this.isConstructor(),u=!(this.isToplevel()||s);if(u){var d=this.getTypeName();// Fixes shim to be backward compatable with Node v0 to v4
"[object Object]"===d&&(d="null");var l=this.getMethodName();i?(d&&0!=i.indexOf(d)&&(t+=d+"."),t+=i,l&&i.indexOf("."+l)!=i.length-l.length-1&&(t+=" [as "+l+"]")):t+=d+"."+(l||"<anonymous>")}else s?t+="new "+(i||"<anonymous>"):i?t+=i:(t+=n,a=!1);return a&&(t+=" ("+n+")"),t}function cloneCallSite(e){var n={};return Object.getOwnPropertyNames(Object.getPrototypeOf(e)).forEach(function(o){n[o]=/^(?:is|get)/.test(o)?function(){return e[o].call(e)}:e[o]}),n.toString=CallSiteToString,n}function wrapCallSite(e){if(e.isNative())return e;// Most call sites will return the source file from getFileName(), but code
// passed to eval() ending in "//# sourceURL=..." will return the source file
// from getScriptNameOrSourceURL() instead
var n=e.getFileName()||e.getScriptNameOrSourceURL();if(n){var o=e.getLineNumber(),r=e.getColumnNumber()-1,t=62;1!==o||!(r>t)||isInBrowser()||e.isEval()||(r-=t);var i=mapSourcePosition({source:n,line:o,column:r});e=cloneCallSite(e);var a=e.getFunctionName;return e.getFunctionName=function(){return i.name||a()},e.getFileName=function(){return i.source},e.getLineNumber=function(){return i.line},e.getColumnNumber=function(){return i.column+1},e.getScriptNameOrSourceURL=function(){return i.source},e}// Code called using eval() needs special handling
var s=e.isEval()&&e.getEvalOrigin();return s?(s=mapEvalOrigin(s),e=cloneCallSite(e),e.getEvalOrigin=function(){return s},e):e;// If we get here then we were unable to change the source position
}// This function is part of the V8 stack trace API, for more info see:
// https://v8.dev/docs/stack-trace-api
function prepareStackTrace(e,n){emptyCacheBetweenOperations&&(fileContentsCache={},sourceMapCache={});var o=e.name||"Error",r=e.message||"";return o+": "+r+n.map(function(e){return"\n    at "+wrapCallSite(e)}).join("")}// Generate position and snippet of original source with pointer
function getErrorSource(e){var n=/\n    at [^(]+ \((.*):(\d+):(\d+)\)/.exec(e.stack);if(n){var o=n[1],r=+n[2],t=+n[3],i=fileContentsCache[o];// Support files on disk
if(!i&&fs&&fs.existsSync(o))try{i=fs.readFileSync(o,"utf8")}catch(e){i=""}// Format the line from the original source code like node does
if(i){var a=i.split(/(?:\r\n|\r|\n)/)[r-1];if(a)return o+":"+r+"\n"+a+"\n"+Array(t).join(" ")+"^"}}return null}function printErrorAndExit(e){var n=getErrorSource(e);// Ensure error is printed synchronously and not truncated
process.stderr._handle&&process.stderr._handle.setBlocking&&process.stderr._handle.setBlocking(!0),n&&(console.error(),console.error(n)),console.error(e.stack),process.exit(1)}function shimEmitUncaughtException(){var e=process.emit;process.emit=function(n){if("uncaughtException"===n){var o=arguments[1]&&arguments[1].stack,r=0<this.listeners(n).length;if(o&&!r)return printErrorAndExit(arguments[1])}return e.apply(this,arguments)}}var originalRetrieveFileHandlers=retrieveFileHandlers.slice(0),originalRetrieveMapHandlers=retrieveMapHandlers.slice(0),wrapCallSite_1=wrapCallSite,getErrorSource_1=getErrorSource,mapSourcePosition_1=mapSourcePosition,retrieveSourceMap_1=retrieveSourceMap,install=function(e){if(e=e||{},e.environment&&(environment=e.environment,-1===["node","browser","auto"].indexOf(environment)))throw new Error("environment "+environment+" was unknown. Available options are {auto, browser, node}");// Allow sources to be found by methods other than reading the files
// directly from disk.
// Support runtime transpilers that include inline source maps
if(e.retrieveFile&&(e.overrideRetrieveFile&&(retrieveFileHandlers.length=0),retrieveFileHandlers.unshift(e.retrieveFile)),e.retrieveSourceMap&&(e.overrideRetrieveSourceMap&&(retrieveMapHandlers.length=0),retrieveMapHandlers.unshift(e.retrieveSourceMap)),e.hookRequire&&!isInBrowser()){var n;try{n=require$$3}catch(e){// NOP: Loading in catch block to convert webpack error to warning.
}var o=n.prototype._compile;o.__sourceMapSupport||(n.prototype._compile=function(e,n){return fileContentsCache[n]=e,sourceMapCache[n]=void 0,o.call(this,e,n)},n.prototype._compile.__sourceMapSupport=!0)}// Configure options
if(emptyCacheBetweenOperations||(emptyCacheBetweenOperations=!!("emptyCacheBetweenOperations"in e)&&e.emptyCacheBetweenOperations),errorFormatterInstalled||(errorFormatterInstalled=!0,Error.prepareStackTrace=prepareStackTrace),!uncaughtShimInstalled){var r=!("handleUncaughtExceptions"in e)||e.handleUncaughtExceptions;// Provide the option to not install the uncaught exception handler. This is
// to support other uncaught exception handlers (in test frameworks, for
// example). If this handler is not installed and there are no other uncaught
// exception handlers, uncaught exceptions will be caught by node's built-in
// exception handler and the process will still be terminated. However, the
// generated JavaScript code will be shown above the stack trace instead of
// the original source code.
r&&hasGlobalProcessEventEmitter()&&(uncaughtShimInstalled=!0,shimEmitUncaughtException())}},resetRetrieveHandlers=function(){retrieveFileHandlers.length=0,retrieveMapHandlers.length=0,retrieveFileHandlers=originalRetrieveFileHandlers.slice(0),retrieveMapHandlers=originalRetrieveMapHandlers.slice(0),retrieveSourceMap=handlerExec(retrieveMapHandlers),retrieveFile=handlerExec(retrieveFileHandlers)},sourceMapSupport={wrapCallSite:wrapCallSite_1,getErrorSource:getErrorSource_1,mapSourcePosition:mapSourcePosition_1,retrieveSourceMap:retrieveSourceMap_1,install:install,resetRetrieveHandlers:resetRetrieveHandlers};sourceMapSupport.install(),exports.FormatErrorWithContextExtension=FormatErrorWithContextExtension;
//# sourceMappingURL=main.js.map
